---
title: Reflect.ownKeys()
slug: Web/JavaScript/Reference/Global_Objects/Reflect/ownKeys
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Reference
  - Reflect
---
<div>{{JSRef}}</div>

<p>The static <strong><code>Reflect.ownKeys()</code></strong> method returns an array of the <code>target</code> object's own property keys.</p>

<div>{{EmbedInteractiveExample("pages/js/reflect-ownkeys.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Reflect.ownKeys(<var>target</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>The target object from which to get the own keys.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{jsxref("Array")}} of the <code><var>target</var></code> object's own property keys.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>A {{jsxref("TypeError")}}, if <code><var>target</var></code> is not an {{jsxref("Object")}}.</p>

<h2 id="Description">Description</h2>

<p>The <code>Reflect.ownKeys</code> method returns an array of the <code><var>target</var></code> object's own property keys. Its return value is equivalent to <code>{{jsxref("Object.getOwnPropertyNames", "Object.getOwnPropertyNames(target)", "", 1)}}.concat({{jsxref("Object.getOwnPropertySymbols", "Object.getOwnPropertySymbols(target)", "", 1)}})</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Reflect.ownKeys">Using Reflect.ownKeys()</h3>

<pre class="brush: js notranslate">Reflect.ownKeys({z: 3, y: 2, x: 1})  // [ "z", "y", "x" ]
Reflect.ownKeys([])                  // ["length"]

let sym = Symbol.for('comet')
let sym2 = Symbol.for('meteor')
let obj = {[sym]: 0, 'str': 0, '773': 0, '0': 0,
           [sym2]: 0, '-1': 0, '8': 0, 'second str': 0}
Reflect.ownKeys(obj)
// [ "0", "8", "773", "str", "-1", "second str", Symbol(comet), Symbol(meteor) ]
// Indexes in numeric order,
// strings in insertion order,
// symbols in insertion order
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-reflect.ownkeys', 'Reflect.ownKeys')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Reflect.ownKeys")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Reflect")}}</li>
 <li>{{jsxref("Object.getOwnPropertyNames()")}}</li>
</ul>
